      subroutine bfaxes(nat,i1,i2,q,x,y,z,r1,r2,r3,rx,ry,rz)
      implicit double precision(a-h,o-z)
      dimension x(10000)
      dimension y(10000)
      dimension z(10000)
      dimension q(10000)
      dimension r1(3),r2(3),r3(3)

      ztot = 0.d0
      rx = 0.d0
      ry = 0.d0
      rz = 0.d0

      do i=1,nat
      rx = rx + x(i) * q(i)
      ry = ry + y(i) * q(i)
      rz = rz + z(i) * q(i)
      ztot = ztot + q(i)
      enddo

      rx = rx / ztot
      ry = ry / ztot
      rz = rz / ztot

      r1(1) = x(i1) - rx
      r1(2) = y(i1) - ry
      r1(3) = z(i1) - rz
      call norm(r1)

      r2(1) = x(i2) - rx
      r2(2) = y(i2) - ry
      r2(3) = z(i2) - rz

      r2r1 = dot(r1,r2)

      r2(1) = r2(1) - r2r1 * r1(1)
      r2(2) = r2(2) - r2r1 * r1(2)
      r2(3) = r2(3) - r2r1 * r1(3)
      call norm(r2)

      call cross(r1,r2,r3)

      return
      end
c
      subroutine norm(r)
      implicit double precision(a-h,o-z)
      dimension r(3)

      rnorm = dsqrt( r(1) * r(1) + r(2) * r(2) + r(3) * r(3) )
      r(1) = r(1) / rnorm
      r(2) = r(2) / rnorm
      r(3) = r(3) / rnorm

      return
      end
c
      double precision function dot(a,b)
      implicit double precision(a-h,o-z)
      dimension a(3),b(3)

      dot = a(1) * b(1) + a(2) * b(2) + a(3) * b(3)

      return
      end
c
      subroutine cross(a,b,c)
      implicit double precision(a-h,o-z)
      dimension a(3),b(3),c(3)

c
c  c = a x b
c

      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end
